/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ssdm.rasdaman_connector;

import rasj.*;
import org.odmg.*;
import java.util.*;

/**
 *
 * @author andan342
 */
public class ConnectorTest {
    String server = "localhost";
    String base = "RASBASE";
    String coll = "mr";
    String port = "7001";
    String user = "rasadmin";
    String passwd = "rasadmin";

    public static void main(String[] args) {
        ConnectorTest ct = new ConnectorTest();

        System.out.println("------------- Inserting new array");
        ct.insertStripes();
    }

    public void insertStripes()
    {
      try {
        // from Application Examples (dev-guide-java.pdf, page 15)
        Transaction myTa = null;
        Database myDb = null;
        OQLQuery myQu = null;

        Implementation myApp = new RasImplementation("http://"+server+":"+port);
        ((RasImplementation)myApp).setUserIdentification(user, passwd);
        myDb = myApp.newDatabase();

        System.out.println("Opening database ...");
        myDb.open(base, Database.OPEN_EXCLUSIVE);

        try {
            System.out.println("Starting transaction ...");
            myTa = myApp.newTransaction();
            myTa.begin();

            // Example 3 (dev-guide-java.pdf, page 31)
            // set up query object for collection creation:
            myQu = myApp.newOQLQuery(); //AA
            myQu.create("create collection test GreySet");
            // finally, execute “create collection” statement:
            myQu.execute();

            // Example 2 (dev-guide-java.pdf, page 30)
            // create 2-D MDD with cell length 1, i.e., type “byte”:
            RasGMArray myMDD = new RasGMArray( new RasMInterval( "[1:400,1:400]"), 1 );
            // byte container for array data, matching in size:
            byte[] mydata = new byte[160000];
            // initialize array as all-black with two grey stripes:
            for(int y=0; y<400; y++)
            {
                for(int x=0; x<400; x++)
                {
                    if((x>99 && x<151) || (x>299 && x<351)) mydata[y*399+x]=100;
                    else mydata[y*399+x]=0;
                }
            }
            // now insert byte array into MDD object
            // (sets only the pointer, no copying takes place!):
            myMDD.setArray(mydata);
            // set the object type name (used for server type checking):
            myMDD.setObjectTypeName("GreyImage");
            RasStorageLayout ms = new RasStorageLayout();
            ms.setTileDomain("[1:200,1:200]");
            ms.setTileSize(40000);
            myMDD.setStorageLayout(ms);
            
            // now create the insert statement:
            myQu = myApp.newOQLQuery(); //AA
            myQu.create("insert into test values $1");
            // let the server generate a new OID for the object to be
            // inserted, and remember this OID locally:
            String myNewOID = myApp.getObjectId( myMDD );
            // bind the MDD value which substitutes formal parameter $1:
            myQu.bind(myMDD); // …and ship the complete statement to the server:
            myQu.execute();
            
            System.out.println("== Committing transaction...");
            myTa.commit();
            System.out.println("== Array inserted with OID = " + myNewOID);
        } catch (Exception ex) {
            ex.printStackTrace();
            myTa.abort();
        } finally {
            myDb.close();
        }
      } catch (Exception e) {
          e.printStackTrace();
      }
    }

}
